/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"strings"
)


// MediaCenterAPIService MediaCenterAPI service
type MediaCenterAPIService service

type ApiCreateMediaCenterFileRequest struct {
	ctx context.Context
	ApiService *MediaCenterAPIService
	channelId string
	mediaCenterFileCreate *MediaCenterFileCreate
}

func (r ApiCreateMediaCenterFileRequest) MediaCenterFileCreate(mediaCenterFileCreate MediaCenterFileCreate) ApiCreateMediaCenterFileRequest {
	r.mediaCenterFileCreate = &mediaCenterFileCreate
	return r
}

func (r ApiCreateMediaCenterFileRequest) Execute() (*MediaCenterFile, *http.Response, error) {
	return r.ApiService.CreateMediaCenterFileExecute(r)
}

/*
CreateMediaCenterFile Create media file

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param channelId
 @return ApiCreateMediaCenterFileRequest
*/
func (a *MediaCenterAPIService) CreateMediaCenterFile(ctx context.Context, channelId string) ApiCreateMediaCenterFileRequest {
	return ApiCreateMediaCenterFileRequest{
		ApiService: a,
		ctx: ctx,
		channelId: channelId,
	}
}

// Execute executes the request
//  @return MediaCenterFile
func (a *MediaCenterAPIService) CreateMediaCenterFileExecute(r ApiCreateMediaCenterFileRequest) (*MediaCenterFile, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *MediaCenterFile
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "MediaCenterAPIService.CreateMediaCenterFile")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/channels/{channel_id}/mediafiles"
	localVarPath = strings.Replace(localVarPath, "{"+"channel_id"+"}", url.PathEscape(parameterValueToString(r.channelId, "channelId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.mediaCenterFileCreate
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCreateMediaCenterFileVariantRequest struct {
	ctx context.Context
	ApiService *MediaCenterAPIService
	channelId string
	mediaCenterFileVariantCreate *MediaCenterFileVariantCreate
}

// 
func (r ApiCreateMediaCenterFileVariantRequest) MediaCenterFileVariantCreate(mediaCenterFileVariantCreate MediaCenterFileVariantCreate) ApiCreateMediaCenterFileVariantRequest {
	r.mediaCenterFileVariantCreate = &mediaCenterFileVariantCreate
	return r
}

func (r ApiCreateMediaCenterFileVariantRequest) Execute() (*MediaCenterFileVariant, *http.Response, error) {
	return r.ApiService.CreateMediaCenterFileVariantExecute(r)
}

/*
CreateMediaCenterFileVariant Create media file variant

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param channelId
 @return ApiCreateMediaCenterFileVariantRequest
*/
func (a *MediaCenterAPIService) CreateMediaCenterFileVariant(ctx context.Context, channelId string) ApiCreateMediaCenterFileVariantRequest {
	return ApiCreateMediaCenterFileVariantRequest{
		ApiService: a,
		ctx: ctx,
		channelId: channelId,
	}
}

// Execute executes the request
//  @return MediaCenterFileVariant
func (a *MediaCenterAPIService) CreateMediaCenterFileVariantExecute(r ApiCreateMediaCenterFileVariantRequest) (*MediaCenterFileVariant, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *MediaCenterFileVariant
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "MediaCenterAPIService.CreateMediaCenterFileVariant")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/channels/{channel_id}/mediafiles/variants"
	localVarPath = strings.Replace(localVarPath, "{"+"channel_id"+"}", url.PathEscape(parameterValueToString(r.channelId, "channelId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.mediaCenterFileVariantCreate
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetChannelMediaCenterFileRequest struct {
	ctx context.Context
	ApiService *MediaCenterAPIService
	channelId string
	id string
}

func (r ApiGetChannelMediaCenterFileRequest) Execute() (*MediaCenterFile, *http.Response, error) {
	return r.ApiService.GetChannelMediaCenterFileExecute(r)
}

/*
GetChannelMediaCenterFile Get media center file



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param channelId
 @param id
 @return ApiGetChannelMediaCenterFileRequest
*/
func (a *MediaCenterAPIService) GetChannelMediaCenterFile(ctx context.Context, channelId string, id string) ApiGetChannelMediaCenterFileRequest {
	return ApiGetChannelMediaCenterFileRequest{
		ApiService: a,
		ctx: ctx,
		channelId: channelId,
		id: id,
	}
}

// Execute executes the request
//  @return MediaCenterFile
func (a *MediaCenterAPIService) GetChannelMediaCenterFileExecute(r ApiGetChannelMediaCenterFileRequest) (*MediaCenterFile, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *MediaCenterFile
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "MediaCenterAPIService.GetChannelMediaCenterFile")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/channels/{channel_id}/mediafiles/{id}"
	localVarPath = strings.Replace(localVarPath, "{"+"channel_id"+"}", url.PathEscape(parameterValueToString(r.channelId, "channelId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetChannelMediaCenterFilesRequest struct {
	ctx context.Context
	ApiService *MediaCenterAPIService
	channelId string
	key *string
	search *string
}

func (r ApiGetChannelMediaCenterFilesRequest) Key(key string) ApiGetChannelMediaCenterFilesRequest {
	r.key = &key
	return r
}

func (r ApiGetChannelMediaCenterFilesRequest) Search(search string) ApiGetChannelMediaCenterFilesRequest {
	r.search = &search
	return r
}

func (r ApiGetChannelMediaCenterFilesRequest) Execute() (*GetChannelMediaCenterFiles200Response, *http.Response, error) {
	return r.ApiService.GetChannelMediaCenterFilesExecute(r)
}

/*
GetChannelMediaCenterFiles Get media center files



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param channelId
 @return ApiGetChannelMediaCenterFilesRequest
*/
func (a *MediaCenterAPIService) GetChannelMediaCenterFiles(ctx context.Context, channelId string) ApiGetChannelMediaCenterFilesRequest {
	return ApiGetChannelMediaCenterFilesRequest{
		ApiService: a,
		ctx: ctx,
		channelId: channelId,
	}
}

// Execute executes the request
//  @return GetChannelMediaCenterFiles200Response
func (a *MediaCenterAPIService) GetChannelMediaCenterFilesExecute(r ApiGetChannelMediaCenterFilesRequest) (*GetChannelMediaCenterFiles200Response, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GetChannelMediaCenterFiles200Response
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "MediaCenterAPIService.GetChannelMediaCenterFiles")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/channels/{channel_id}/mediafiles"
	localVarPath = strings.Replace(localVarPath, "{"+"channel_id"+"}", url.PathEscape(parameterValueToString(r.channelId, "channelId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.key != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "key", r.key, "")
	}
	if r.search != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "search", r.search, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetMediaCenterFileVaariantRequest struct {
	ctx context.Context
	ApiService *MediaCenterAPIService
	channelId string
	variantId string
}

func (r ApiGetMediaCenterFileVaariantRequest) Execute() (*MediaCenterFileVariant, *http.Response, error) {
	return r.ApiService.GetMediaCenterFileVaariantExecute(r)
}

/*
GetMediaCenterFileVaariant Get a Channel Mediafile Variant

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param channelId
 @param variantId
 @return ApiGetMediaCenterFileVaariantRequest
*/
func (a *MediaCenterAPIService) GetMediaCenterFileVaariant(ctx context.Context, channelId string, variantId string) ApiGetMediaCenterFileVaariantRequest {
	return ApiGetMediaCenterFileVaariantRequest{
		ApiService: a,
		ctx: ctx,
		channelId: channelId,
		variantId: variantId,
	}
}

// Execute executes the request
//  @return MediaCenterFileVariant
func (a *MediaCenterAPIService) GetMediaCenterFileVaariantExecute(r ApiGetMediaCenterFileVaariantRequest) (*MediaCenterFileVariant, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *MediaCenterFileVariant
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "MediaCenterAPIService.GetMediaCenterFileVaariant")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/channels/{channel_id}/mediafiles/variants/{variant_id}"
	localVarPath = strings.Replace(localVarPath, "{"+"channel_id"+"}", url.PathEscape(parameterValueToString(r.channelId, "channelId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"variant_id"+"}", url.PathEscape(parameterValueToString(r.variantId, "variantId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetMediaCenterFileVariantsRequest struct {
	ctx context.Context
	ApiService *MediaCenterAPIService
	type_ *string
	search *string
	organizationId *string
	channelId *string
	default_ *string
	external *string
}

func (r ApiGetMediaCenterFileVariantsRequest) Type_(type_ string) ApiGetMediaCenterFileVariantsRequest {
	r.type_ = &type_
	return r
}

func (r ApiGetMediaCenterFileVariantsRequest) Search(search string) ApiGetMediaCenterFileVariantsRequest {
	r.search = &search
	return r
}

func (r ApiGetMediaCenterFileVariantsRequest) OrganizationId(organizationId string) ApiGetMediaCenterFileVariantsRequest {
	r.organizationId = &organizationId
	return r
}

func (r ApiGetMediaCenterFileVariantsRequest) ChannelId(channelId string) ApiGetMediaCenterFileVariantsRequest {
	r.channelId = &channelId
	return r
}

func (r ApiGetMediaCenterFileVariantsRequest) Default_(default_ string) ApiGetMediaCenterFileVariantsRequest {
	r.default_ = &default_
	return r
}

func (r ApiGetMediaCenterFileVariantsRequest) External(external string) ApiGetMediaCenterFileVariantsRequest {
	r.external = &external
	return r
}

func (r ApiGetMediaCenterFileVariantsRequest) Execute() (*GetMediaCenterFileVariants200Response, *http.Response, error) {
	return r.ApiService.GetMediaCenterFileVariantsExecute(r)
}

/*
GetMediaCenterFileVariants 

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiGetMediaCenterFileVariantsRequest
*/
func (a *MediaCenterAPIService) GetMediaCenterFileVariants(ctx context.Context) ApiGetMediaCenterFileVariantsRequest {
	return ApiGetMediaCenterFileVariantsRequest{
		ApiService: a,
		ctx: ctx,
	}
}

// Execute executes the request
//  @return GetMediaCenterFileVariants200Response
func (a *MediaCenterAPIService) GetMediaCenterFileVariantsExecute(r ApiGetMediaCenterFileVariantsRequest) (*GetMediaCenterFileVariants200Response, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GetMediaCenterFileVariants200Response
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "MediaCenterAPIService.GetMediaCenterFileVariants")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/mediafiles/variants"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.type_ != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "type", r.type_, "")
	}
	if r.search != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "search", r.search, "")
	}
	if r.organizationId != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "organization_id", r.organizationId, "")
	}
	if r.channelId != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "channel_id", r.channelId, "")
	}
	if r.default_ != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "default", r.default_, "")
	}
	if r.external != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "external", r.external, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetMediaFileVariantByKeyRequest struct {
	ctx context.Context
	ApiService *MediaCenterAPIService
	channelId string
	fileKey string
	variantKey string
}

func (r ApiGetMediaFileVariantByKeyRequest) Execute() (*MediaCenterFileVariant, *http.Response, error) {
	return r.ApiService.GetMediaFileVariantByKeyExecute(r)
}

/*
GetMediaFileVariantByKey Get media center variant by key

Get media center variant by key

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param channelId
 @param fileKey
 @param variantKey
 @return ApiGetMediaFileVariantByKeyRequest
*/
func (a *MediaCenterAPIService) GetMediaFileVariantByKey(ctx context.Context, channelId string, fileKey string, variantKey string) ApiGetMediaFileVariantByKeyRequest {
	return ApiGetMediaFileVariantByKeyRequest{
		ApiService: a,
		ctx: ctx,
		channelId: channelId,
		fileKey: fileKey,
		variantKey: variantKey,
	}
}

// Execute executes the request
//  @return MediaCenterFileVariant
func (a *MediaCenterAPIService) GetMediaFileVariantByKeyExecute(r ApiGetMediaFileVariantByKeyRequest) (*MediaCenterFileVariant, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *MediaCenterFileVariant
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "MediaCenterAPIService.GetMediaFileVariantByKey")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/channels/{channel_id}/mediafiles/keys/{file_key}/variants/keys/{variant_key}"
	localVarPath = strings.Replace(localVarPath, "{"+"channel_id"+"}", url.PathEscape(parameterValueToString(r.channelId, "channelId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"file_key"+"}", url.PathEscape(parameterValueToString(r.fileKey, "fileKey")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"variant_key"+"}", url.PathEscape(parameterValueToString(r.variantKey, "variantKey")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetMediaFileVariantDefaultRequest struct {
	ctx context.Context
	ApiService *MediaCenterAPIService
	channelId string
	fileKey string
}

func (r ApiGetMediaFileVariantDefaultRequest) Execute() (*MediaCenterFileVariant, *http.Response, error) {
	return r.ApiService.GetMediaFileVariantDefaultExecute(r)
}

/*
GetMediaFileVariantDefault Get media center default variant

Get media center default variant

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param channelId
 @param fileKey
 @return ApiGetMediaFileVariantDefaultRequest
*/
func (a *MediaCenterAPIService) GetMediaFileVariantDefault(ctx context.Context, channelId string, fileKey string) ApiGetMediaFileVariantDefaultRequest {
	return ApiGetMediaFileVariantDefaultRequest{
		ApiService: a,
		ctx: ctx,
		channelId: channelId,
		fileKey: fileKey,
	}
}

// Execute executes the request
//  @return MediaCenterFileVariant
func (a *MediaCenterAPIService) GetMediaFileVariantDefaultExecute(r ApiGetMediaFileVariantDefaultRequest) (*MediaCenterFileVariant, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *MediaCenterFileVariant
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "MediaCenterAPIService.GetMediaFileVariantDefault")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/channels/{channel_id}/mediafiles/keys/{file_key}/variants/default"
	localVarPath = strings.Replace(localVarPath, "{"+"channel_id"+"}", url.PathEscape(parameterValueToString(r.channelId, "channelId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"file_key"+"}", url.PathEscape(parameterValueToString(r.fileKey, "fileKey")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiUpdateMediaCenterFileRequest struct {
	ctx context.Context
	ApiService *MediaCenterAPIService
	channelId string
	id string
	mediaCenterFileUpdate *MediaCenterFileUpdate
}

func (r ApiUpdateMediaCenterFileRequest) MediaCenterFileUpdate(mediaCenterFileUpdate MediaCenterFileUpdate) ApiUpdateMediaCenterFileRequest {
	r.mediaCenterFileUpdate = &mediaCenterFileUpdate
	return r
}

func (r ApiUpdateMediaCenterFileRequest) Execute() (*MediaCenterFile, *http.Response, error) {
	return r.ApiService.UpdateMediaCenterFileExecute(r)
}

/*
UpdateMediaCenterFile Update media center file

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param channelId
 @param id
 @return ApiUpdateMediaCenterFileRequest
*/
func (a *MediaCenterAPIService) UpdateMediaCenterFile(ctx context.Context, channelId string, id string) ApiUpdateMediaCenterFileRequest {
	return ApiUpdateMediaCenterFileRequest{
		ApiService: a,
		ctx: ctx,
		channelId: channelId,
		id: id,
	}
}

// Execute executes the request
//  @return MediaCenterFile
func (a *MediaCenterAPIService) UpdateMediaCenterFileExecute(r ApiUpdateMediaCenterFileRequest) (*MediaCenterFile, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *MediaCenterFile
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "MediaCenterAPIService.UpdateMediaCenterFile")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/channels/{channel_id}/mediafiles/{id}"
	localVarPath = strings.Replace(localVarPath, "{"+"channel_id"+"}", url.PathEscape(parameterValueToString(r.channelId, "channelId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.mediaCenterFileUpdate
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiUpdateMediaCenterFileVariantRequest struct {
	ctx context.Context
	ApiService *MediaCenterAPIService
	channelId string
	variantId string
	updateMediaCenterFileVariantRequest *UpdateMediaCenterFileVariantRequest
}

// 
func (r ApiUpdateMediaCenterFileVariantRequest) UpdateMediaCenterFileVariantRequest(updateMediaCenterFileVariantRequest UpdateMediaCenterFileVariantRequest) ApiUpdateMediaCenterFileVariantRequest {
	r.updateMediaCenterFileVariantRequest = &updateMediaCenterFileVariantRequest
	return r
}

func (r ApiUpdateMediaCenterFileVariantRequest) Execute() (*MediaCenterFileVariant, *http.Response, error) {
	return r.ApiService.UpdateMediaCenterFileVariantExecute(r)
}

/*
UpdateMediaCenterFileVariant Update media file variant



 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param channelId
 @param variantId
 @return ApiUpdateMediaCenterFileVariantRequest
*/
func (a *MediaCenterAPIService) UpdateMediaCenterFileVariant(ctx context.Context, channelId string, variantId string) ApiUpdateMediaCenterFileVariantRequest {
	return ApiUpdateMediaCenterFileVariantRequest{
		ApiService: a,
		ctx: ctx,
		channelId: channelId,
		variantId: variantId,
	}
}

// Execute executes the request
//  @return MediaCenterFileVariant
func (a *MediaCenterAPIService) UpdateMediaCenterFileVariantExecute(r ApiUpdateMediaCenterFileVariantRequest) (*MediaCenterFileVariant, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *MediaCenterFileVariant
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "MediaCenterAPIService.UpdateMediaCenterFileVariant")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/channels/{channel_id}/mediafiles/variants/{variant_id}"
	localVarPath = strings.Replace(localVarPath, "{"+"channel_id"+"}", url.PathEscape(parameterValueToString(r.channelId, "channelId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"variant_id"+"}", url.PathEscape(parameterValueToString(r.variantId, "variantId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json", "multipart/form-data"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.updateMediaCenterFileVariantRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
